import Tools.IO.*;                              // Eingaben

/**
 * PI mittels Monte-Carlo
 */
public class MonteCarlo
{
/**
 * Eingabe der Punktanzahl,
 * Berechnung und Ausgabe der Naeherung von PI
 * und des absoluten Fehlers zu Math.PI.
 */
  public static void main( String[] args)
  {
    System.out.println();
    System.out.println
    ( "Monte Carlo Verfahren zur Bestimmung von PI");

    // Anzahl der zu erzeugenden Zufallspunkte
    int punktAnzahl = IOTools.readInteger
    ( "Wie viele zufaellige Punkte sollen erzeugt werden? ");

    // Zufallspunkte
    int punkteUnterKreisbogen = 0;
    double x_pos, y_pos, pi;

    for(int i = 1; i <= punktAnzahl; i++)
    {
      // Zufallspunkt erzeugen
      x_pos = Math.random();
      y_pos = Math.random();

      // Punkt unterhalb des Kreisbogens
      if((x_pos * x_pos) + (y_pos * y_pos) < 1.)
        punkteUnterKreisbogen++;
    }

    // Verhltnis Anzahl Punkte unterhalb des Kreisbogens
    // zur Gesamtpunktzahl multipliziert mit 4 ergibt PI
    pi = 4. * (double)punkteUnterKreisbogen
            / (double)punktAnzahl;

    // absoluter Fehler
    double absFehler = Math.abs( Math.PI - pi);
    // double relFehler = Math.abs( Math.PI - pi) / Math.PI;

    //Ausgaben
    System.out.println();
    System.out.println( "Punktzahl\t\t: " + punktAnzahl);
    System.out.println( "\"MonteCarlo-PI\"\t\t: " + pi);
    System.out.println( "\"Math.PI\"\t\t: " + Math.PI);
    System.out.println( "Absoluter Fehler\t: " + absFehler);
  }
}

/*
Monte Carlo Verfahren zur Bestimmung von PI

Wie viele zufaellige Punkte sollen erzeugt werden? 
Punktzahl		: 1000
"MonteCarlo-PI"		: 3.212
"Math.PI"		: 3.141592653589793
Absoluter Fehler	: 0.07040734641020707

Monte Carlo Verfahren zur Bestimmung von PI

Wie viele zufaellige Punkte sollen erzeugt werden? 
Punktzahl		: 1000000
"MonteCarlo-PI"		: 3.14114
"Math.PI"		: 3.141592653589793
Absoluter Fehler	: 4.526535897930728E-4

Monte Carlo Verfahren zur Bestimmung von PI

Wie viele zufaellige Punkte sollen erzeugt werden? 
Punktzahl		: 1000000000
"MonteCarlo-PI"		: 3.141579012
"Math.PI"		: 3.141592653589793
Absoluter Fehler	: 1.3641589793333964E-5
*/
